// -*- C++ -*-
/***************************************************************************
                          libmorse part of Aldo
                          ---------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#ifndef MORSE_H
#define MORSE_H

#include "keyer.h"
#include <list>
#include <fstream>

namespace libmorse
{
    enum signal { dot=1, line=3 };

    class Morse_char
    {
	friend std::ofstream& operator<<(std::ofstream&, const Morse_char&);
	friend libkeyer::Keyer& operator<<(libkeyer::Keyer&, const Morse_char&);
	
    private:
	char m_char;
	std::list<signal> m_signals;
	
    public:
	Morse_char();
	Morse_char(const Morse_char&);
	Morse_char(const char&);
    };
    
    class Morse_string
    {
	friend std::ofstream& operator<<(std::ofstream&, const Morse_string&);
	friend libkeyer::Keyer& operator<<(libkeyer::Keyer&, const Morse_string&);
    
    private:
	std::list<Morse_char> m_string;    
	
    public:
	Morse_string();
	Morse_string(const Morse_string&);
	Morse_string& operator+=(unsigned char);
	Morse_string(const std::string&);
    };
}
#endif // MORSE_H
