/***************************************************************************
                           libmenu
                          --------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#pragma implementation
// #include "dialog.h"

#include <iostream>

using namespace std;

export template <class T>
Choice<T>::Choice():m_caption("Empty"),m_return_value(0)
{}

export template <class T>
Choice<T>::Choice(std::string c, T v): m_caption(c), m_return_value(v)
{}

export template <class T>
std::string Choice<T>::caption() const
{
    return m_caption;
}

export template <class T>
T Choice<T>::selected() const
{
    return m_return_value;
}

export template <class T>
Dialog<T>::Dialog(): m_title("Dialog"), m_prompt("Prompt:")
{}

export template <class T>
Dialog<T>::Dialog(std::string t, std::string p):m_title(t), m_prompt(p)
{}

export template <class T>
Dialog<T>::Dialog(const Dialog& copy)
{
    m_title = copy.m_title;
    m_prompt = copy.m_prompt;
    m_choices = copy.m_choices;
}

export template <class T>
void Dialog<T>::add_choice(std::string c, T r)
{
    m_choices.push_back(Choice<T>(c,r));
}

export template <class T>
T Dialog<T>::show()
{
    cout<<m_title<<endl;
    for(unsigned int i=0; i<m_choices.size();i++)
    {
	cout<<"\t"<<i+1<<": "<<m_choices[i].caption()<<endl;
    }
    
    unsigned int choice;
    do
    {
	cout<<endl<<m_prompt;
	cin>>choice;
	choice--;
    }
    while( choice > m_choices.size() );

    return m_choices.at(choice).selected();
}
