/***************************************************************************
                          libmorse part of Aldo
                          ---------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#include "morse.h"
#include <string>

using namespace std;
using namespace libmorse;

typedef list<libmorse::signal>::const_iterator signal_cit;
typedef list<Morse_char>::const_iterator string_cit;

Morse_char::Morse_char():m_char(0)
{
    m_signals.clear();
}

Morse_char::Morse_char(const Morse_char& cpy): m_char(cpy.m_char)
{
    m_signals = cpy.m_signals;
}

Morse_char::Morse_char(const char& ch)
{
    m_char = ch;
    
    switch(m_char)
    {
    case 'a':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    
    case 'b':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
	
    case 'c':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 'd':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case 'e':
    {
	m_signals.push_back(dot);
	break;
    }
    case 'f':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 'g':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 'h':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case 'i':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case 'j':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case 'k':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case 'l':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case 'm':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case 'n':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 'o':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case 'p':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 'q':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case 'r':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case 's':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case 't':
    {
	m_signals.push_back(line);
	break;
    }
    case 'u':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case 'v':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case 'w':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case 'x':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case 'y':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case 'z':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case '1':
    {
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case '2':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case '3':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    case '4':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(line);
	break;
    }
    case '5':
    {
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case '6':
    {
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case '7':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case '8':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	m_signals.push_back(dot);
	break;
    }
    case '9':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(dot);
	break;
    }
    case '0':
    {
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	m_signals.push_back(line);
	break;
    }
    }
}

Morse_string::Morse_string()
{}

Morse_string::Morse_string(const Morse_string& cpy)
{
    m_string = cpy.m_string;
}

Morse_string& Morse_string::operator+=(unsigned char ch)
{
    m_string.push_back(ch);
    return(*this);
}

Morse_string::Morse_string(const string& strl)
{
    for(unsigned int i=0;i<strl.size();i++)
	m_string.push_back(strl[i]);
}

libkeyer::Keyer& libmorse::operator<<(libkeyer::Keyer& audio, const Morse_char& s)
{
    for(signal_cit it=s.m_signals.begin(); it!=s.m_signals.end(); it++)
	audio<<*it;
    audio.char_pause();
    return audio;
}

libkeyer::Keyer& libmorse::operator<<(libkeyer::Keyer& audio, const Morse_string& b)
{
    for(string_cit it=b.m_string.begin(); it!=b.m_string.end(); it++)
	audio<<*it;
    audio.string_pause();
    return audio;
}

ofstream& libmorse::operator<<(ofstream& file, const Morse_char& s)
{
    file.put(s.m_char);
    return file;
}

ofstream& libmorse::operator<<(ofstream& file, const Morse_string& b)
{
    for(string_cit it=b.m_string.begin(); it!=b.m_string.end(); it++)
	file<<*it;
    return file;
}
